searchNodes=[{"ref":"CORSPlug.html","title":"CORSPlug","type":"module","doc":""},{"ref":"CORSPlug.html#defaults/0","title":"CORSPlug.defaults/0","type":"function","doc":""},{"ref":"CORSPlug.html#origin_in_list?/2","title":"CORSPlug.origin_in_list?/2","type":"function","doc":""},{"ref":"CORSPlug.html#origins_match?/2","title":"CORSPlug.origins_match?/2","type":"function","doc":""},{"ref":"readme.html","title":"CorsPlug","type":"extras","doc":"CorsPlug An Elixir Plug to add CORS."},{"ref":"readme.html#usage","title":"CorsPlug - Usage","type":"extras","doc":"Add this plug to your mix.exs dependencies: def deps do # ... {:cors_plug, &quot;~&gt; 2.0&quot;}, #... end When used together with the awesomeness that&#39;s the Phoenix Framework please note that putting the CORSPlug in a pipeline won&#39;t work as they are only invoked for matched routes. I therefore recommend to put it in lib/your_app/endpoint.ex: defmodule YourApp.Endpoint do use Phoenix.Endpoint, otp_app: :your_app # ... plug CORSPlug plug YourApp.Router end Alternatively you can add options routes, as suggested by @leighhalliday scope &quot;/api&quot;, PhoenixApp do pipe_through :api resources &quot;/articles&quot;, ArticleController options &quot;/articles&quot;, ArticleController, :options options &quot;/articles/:id&quot;, ArticleController, :options end"},{"ref":"readme.html#compatibility","title":"CorsPlug - Compatibility","type":"extras","doc":"Whenever I get around to, I will bump the plug dependency to the latest version of plug. This will ensure compatibility with the latest plug versions. As of Elixir and OTP, my goal is to test against the three most recent versions respectively."},{"ref":"readme.html#configuration","title":"CorsPlug - Configuration","type":"extras","doc":"This plug will return the following headers: On preflight (OPTIONS) requests: Access-Control-Allow-Origin Access-Control-Allow-Credentials Access-Control-Max-Age Access-Control-Allow-Headers Access-Control-Allow-Methods On GET, POST, ... requests: Access-Control-Allow-Origin Access-Control-Expose-Headers Access-Control-Allow-Credentials You can configure allowed origins using one of the following methods: Using a list Lists can now be comprised of strings, regexes or a mix of both: plug CORSPlug, origin: [&quot;http://example1.com&quot;, &quot;http://example2.com&quot;, ~r/https?.*example\\d?\\.com$/] Using a regex plug CORSPlug, origin: ~r/https?.*example\\d?\\.com$/ Using the config.exs file config :cors_plug, origin: [&quot;http://example.com&quot;], max_age: 86400, methods: [&quot;GET&quot;, &quot;POST&quot;] Using a function/0 or function/1 that returns the allowed origin as a string Caveat: Anonymous functions are not possible as they can&#39;t be quoted. plug CORSPlug, origin: &amp;MyModule.my_fun/0 def my_fun do [&quot;http://example.com&quot;] end plug CORSPlug, origin: &amp;MyModule.my_fun/1 def my_fun(conn) do # Do something with conn [&quot;http://example.com&quot;] end send_preflight_response? There may be times when you would like to retain control over the response sent to OPTIONS requests. If you would like CORSPlug to only set headers, then set the send_preflight_response? option to false. plug CORSPlug, send_preflight_response?: false # or in the app config config :cors_plug, send_preflight_response?: false Please note that options passed to the plug overrides app config but app config overrides default options. Please find the list of current defaults in cors_plug.ex. As per the W3C Recommendation the string null is returned when no configured origin matched the request."},{"ref":"readme.html#license","title":"CorsPlug - License","type":"extras","doc":"Copyright 2020 Michael Schaefermeyer Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License."},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#v2-0-1","title":"Changelog - v2.0.1","type":"extras","doc":"Enhancements Passing a function with arity 2 as origin will pass the conn to the function, allowing configuration based on conn (thanks @billionlaughs). You can now pass regexes as part of the list of origins (thanks @gabrielpra1). Fixes Fixes an issue where the request was missing the access-control-request-headers (thanks @zhhz for the initial report and @mfeckie for the fix)."},{"ref":"changelog.html#v2-0-0","title":"Changelog - v2.0.0","type":"extras","doc":"Enhancements Instead of sending &quot;null&quot; we don&#39;t set the headers at all if the origin doesn&#39;t match, as suggested by the CORS draft 7.2. Thanks to @YuLeven for initiating the discussion and @slashmili for fixing it. Since we change the return values I consider this a breaking change and released a new major version. You can now set the option send_preflight_response? to false (it&#39;s true by default) to stop CorsPlug sending a response to the preflight request. That way the correct headers are set but it&#39;s up to you to respond to the request downstream."},{"ref":"changelog.html#v1-5-2","title":"Changelog - v1.5.2","type":"extras","doc":"Fixes Relax version requirements"},{"ref":"changelog.html#v1-5-1","title":"Changelog - v1.5.1","type":"extras","doc":"Fixes Send proper return value if Access-Control-Request-Headers is not present. (thanks @shivamMg)"},{"ref":"changelog.html#v1-5-0","title":"Changelog - v1.5.0","type":"extras","doc":"Enhancements Allow configuration of origin via function (thanks @mauricioszabo)."},{"ref":"changelog.html#v1-4-0","title":"Changelog - v1.4.0","type":"extras","doc":"Enhancements Allows both * as well as specific domains in the origins config, returns the corresponding value (thanks @mustafaturan) Fixes Don&#39;t overwrite vary header values with &quot;Origin&quot;, instead append it. Don&#39;t set vary header to empty string if not needed. Use Plug.Conn.merge_resp_headers/2 New major release because of the vary header changes, I don&#39;t expect this to break anything."},{"ref":"changelog.html#v1-3-0","title":"Changelog - v1.3.0","type":"extras","doc":"Enhancements Allows configuration via app config (see README.md, thanks @TokiTori)."},{"ref":"changelog.html#v1-2-1","title":"Changelog - v1.2.1","type":"extras","doc":"Fixes Match for exact origin only (thanks @somlor and @JordanAdams). Add Vary to response header (thanks @linjunpop)."},{"ref":"changelog.html#v1-2-0","title":"Changelog - v1.2.0","type":"extras","doc":"Fixes Remove cowboy dependency. Plug should be server-agnostic and this plug does not need cowboy. Thanks to @hauleth and @ewitchin for making me aware. As I changed dependency this is a minor release. I don&#39;t anticipate any regressions tho."},{"ref":"changelog.html#v1-1-4","title":"Changelog - v1.1.4","type":"extras","doc":"Fixes Add method parens to suppress Elixir 1.4.0 warnings (thanks @seivan)."},{"ref":"changelog.html#v1-1-3","title":"Changelog - v1.1.3","type":"extras","doc":"Enhancements Support regex for origin (thanks @somlor)"},{"ref":"changelog.html#v1-1-2","title":"Changelog - v1.1.2","type":"extras","doc":"Enhancements Allow client to set allow-headers by sending request-headers when using a wildcard. This enhancement is brought to you by @arathunku"},{"ref":"changelog.html#v1-1-1","title":"Changelog - v1.1.1","type":"extras","doc":"Fixes Return &quot;null&quot; instead of null when no origin matches. Many thanks to @somlor for the fix!"},{"ref":"changelog.html#v1-1-0","title":"Changelog - v1.1.0","type":"extras","doc":"Enhancements Allow multiple origins. When configuring you can now pass a list for origins (plug: CORSPlug, origin: ~w(example1.com example2.com)). Fixes Access-Control-Expose-Headers now works Both of these have been brought to you by @jer-k - many thanks!"},{"ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras","doc":"Fixes Don&#39;t override headers. Earlier headers would&#39;ve been overriden by the CORS Plug. Amazing that this hasn&#39;t popped up before... As this makes a backward-incompatible change (no longer overriding headers this is a new major)."},{"ref":"changelog.html#v0-1-4","title":"Changelog - v0.1.4","type":"extras","doc":"Enhancements Add Access-Control-Expose-Headers (thanks @jaketrent)"},{"ref":"changelog.html#v0-1-3","title":"Changelog - v0.1.3","type":"extras","doc":"Enhancements Add license Improve readme (thanks @leighhalliday, @patricksrobertson) Simplify travis.yml (thanks @lowks)"},{"ref":"changelog.html#v0-1-2","title":"Changelog - v0.1.2","type":"extras","doc":"Release plug dependency"}]